#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const ll maxN=10000000;

int q;
ll n;
vector<ll> ans;

void init()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    scanf("%d",&q);
}

bool sqn(ll x)
{
    ll i=2;
    bool ff=0;
    while(x>1)
    {
        if(x%i==0)
        {
            if(ff) return true;
            ff=true;
            x/=i;
        }
        else
        {
            i++;
            ff=false;
        }
    }

    return false;
}

ll solve()
{
    ll ret=0;
    for(ll i=1;i<=n;i++)
        if(!sqn(i))
            ret++;
    return ret;
}

int main()
{
    init();
    for(int i=0;i<q;i++)
    {
        scanf("%lld",&n);
        ans.push_back(solve());
    }

    for(int i=0;i<q;i++)
        printf("%lld\n",ans[i]);
}
