#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const ll maxN=10000;

int q;
ll n;
vector<ll> ans;
vector<ll> pr;

bool a[maxN];

void init()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    scanf("%d",&q);
}

void erathosten()
{
    int i=2;

    while(i<=maxN)
    {
        if(!a[i])
        {
            pr.push_back(i);
            for(int j=i*i;j<=maxN;j+=i)
                a[j]=true;
        }
        i++;
    }
}

bool sqn(ll x)
{
    ll i=0;
    bool ff=0;
    while(x>1)
    {
        if(x%pr[i]==0)
        {
            if(ff) return true;
            ff=true;
            x/=pr[i];
        }
        else
        {
            i++;
            ff=false;
        }
    }

    return false;
}

ll cnt()
{
    ll ret=n;

    ll y=2;
    while(y*y<=n)
    {
        for(ll i=1;y*y*i<=n;i++)
        {
            if(sqn(y)) break;
            if(sqn(i)) continue;
            ret--;
        }
        y++;
    }

    return ret;
}

int main()
{
    init();

    erathosten();

    for(int i=0;i<q;i++)
    {
        scanf("%lld",&n);

        ans.push_back(cnt());
    }

    for(int i=0;i<q;i++)
    {
        printf("%lld\n",ans[i]);
    }

    return 0;
}
