#include <iostream>
#include <vector>

using namespace std;

const int MAXSUM = 250001;

int n,q;
int a[512];
int l,r,u,v;

vector<int> ans;

bool can[MAXSUM][500];
bool knw[MAXSUM][500];
int pref[512];

bool ff(int i,int sum)
{
    if(sum==0) return true;
    if(sum<0) return false;
    if(i>r) return false;
    if(knw[sum][i]) return can[sum][i];

    can[sum][i] = (ff(i+1,sum)||ff(i+1,sum-a[i]));
    knw[sum][i]=true;

    return can[sum][i];
}

int querty(int i,int j)
{
    if(i==0) return pref[j];
    return pref[j]-pref[i-1];
}

void init()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    scanf("%d%d%d",&n,&q,&a[0]);
    pref[0]=a[0];
    for(int i=1;i<n;i++)
    {
        scanf("%d",&a[i]);
        pref[i]=pref[i-1]+a[i];
    }
}

int main()
{
    init();

    for(int i=0;i<q;i++)
    {
        scanf("%d%d%d%d",&l,&r,&u,&v);
        l--;
        r--;
        for(int i=1;i<=min(v,querty(l,r));i++)
        {
            for(int j=0;j<500;j++)
            {
                 can[i][j]=false;
            knw[i][j]=false;
            }

        }

        int br=0;
        for(int j=u;j<=min(v,querty(l,r));j++)
            if(ff(l,j))
            {
                br++;
            }
        ans.push_back(br);
    }

    for(int i=0;i<q;i++)
        printf("%d\n",ans[i]);

    return 0;
}
/*
5 2
12 3 4 6 8
2 4 6 15
1 5 1 1000
*/
