#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e14+2;
const int MAXQ=512;
const ll MAXM=1e7+2;
bool p[MAXM];
vector<int>primes;
void eratosten()
{
    primes.push_back(2);
    for(int i=3;i<MAXM;i+=2)
    {
        if(p[i]==0)
        {
            primes.push_back(i);
            for(int j=3;j*i<MAXM;j+=2)
            {
                p[j*i]=1;
            }
        }
    }
}
vector<ll>prime_squares;
vector<ll>comb[2][3];
ll cur=1,cnt;
int border;
void find_all_combs(int idx)
{
    if(idx==border)return;
    //cout<<prime_squares[idx]*cur<<endl;
    if(prime_squares[idx]>=MAXN/cur)return;
    find_all_combs(idx+1);
    cur*=prime_squares[idx];
    cnt++;
    int b1=cnt%2;
    int b2=2;
    if(cur>=MAXN/prime_squares[border])b2=0;
    else if(cur>=MAXN/prime_squares[border]/prime_squares[border+1])b2=1;
    comb[b1][b2].push_back(cur);
    find_all_combs(idx+1);
    cnt--;
    cur/=prime_squares[idx];
}
void solve(ll n)
{
    ll ans=0;

    for(auto xd:comb[1][0])
    {
        ans+=n/xd;
    }
    //cout<<"&& "<<ans<<endl;
    for(auto xd:comb[0][0])
    {
        ans-=n/xd;
    }
    //cout<<"&& "<<ans<<endl;
    for(auto xd:comb[0][1])
    {
        ll m=n/xd;
        ll low=border,high=prime_squares.size()-1,mid,best=border-1;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(prime_squares[mid]<=m)
            {
                best=mid;
                low=mid+1;
            }
            else
            {
                high=mid-1;
            }
        }
        ans+=best-border+1;
    }
    //cout<<"&& "<<ans<<endl;
    for(auto xd:comb[1][1])
    {
        ll m=n/xd;
        ll low=border,high=prime_squares.size()-1,mid,best=border-1;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(prime_squares[mid]<=m)
            {
                best=mid;
                low=mid+1;
            }
            else
            {
                high=mid-1;
            }
        }
        ans-=best-border+1;
    }
    //cout<<"&& "<<ans<<endl;
    for(auto xd:comb[0][2])
    {
        ll m=n/xd;
        ll low=border,high=prime_squares.size()-1,mid,best=border-1;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(prime_squares[mid]<=m/prime_squares[border])
            {
                best=mid;
                low=mid+1;
            }
            else
            {
                high=mid-1;
            }
        }
        int ptr=border;
        ll cnt=0;
        for(int j=best;j>border;j--)
        {
            while(ptr>=j)ptr--;
            while(ptr+1<j&&prime_squares[j]<=m/prime_squares[ptr+1])
            {
                ptr++;
            }
            cnt+=ptr-border+1;
        }
        ans-=cnt;
    }
    //cout<<"&& "<<ans<<endl;
    for(auto xd:comb[1][2])
    {
        ll m=n/xd;
        ll low=border,high=prime_squares.size()-1,mid,best=border-1;
        while(low<=high)
        {
            mid=(low+high)/2;
            if(prime_squares[mid]<=m/prime_squares[border])
            {
                best=mid;
                low=mid+1;
            }
            else
            {
                high=mid-1;
            }
        }
        int ptr=border;
        ll cnt=0;
        for(int j=best;j>border;j--)
        {
            while(ptr>=j)ptr--;
            while(ptr+1<j&&prime_squares[j]<=m/prime_squares[ptr+1])
            {
                ptr++;
            }
            cnt+=ptr-border+1;
        }
        ans+=cnt;
    }
    cout<<ans<<endl;
}
void slow(ll n)
{
    ll ans=0;
    for(int i=1;i<=n;i++)
    {
        bool flag=true;
        for(auto xd:prime_squares)
        {
            if(xd>i)break;
            if(i%xd==0)
            {
                flag=false;
                break;
            }
        }
        if(flag)ans++;
    }
    cout<<n-ans<<endl;
}
int main()
{
    eratosten();
    for(auto xd:primes)
    {
        prime_squares.push_back((ll)xd*xd);
    }
    for(int i=0;i<prime_squares.size();i++)
    {
        if(prime_squares[i]>=MAXN/prime_squares[i+1]/prime_squares[i+2])
        {
            border=i;break;
        }
    }
    border=200;
    //cout<<border<<" "<<primes.size()<<endl;
    find_all_combs(0);
    /*for(int i=0;i<2;i++)
    {
        for(int j=0;j<3;j++)
        {
            cout<<i<<" "<<j<<" "<<comb[i][j].size()<<endl;
        }
    }*/
    for(int i=0;i<2;i++)
    {
        for(int j=0;j<3;j++)
        {
            for(int j1=0;j1<j;j1++)
            {
                for(auto xd:comb[i][j])
                {
                    comb[i][j1].push_back(xd);
                }
            }
        }
    }
    /*for(int i=0;i<2;i++)
    {
        for(int j=0;j<3;j++)
        {
            cout<<i<<" "<<j<<" "<<comb[i][j].size()<<endl;
        }
    }*/
    int q;
    cin>>q;
    while(q--)
    {
        ll n;
        cin>>n;
        solve(n);
        //slow(n);
    }
return 0;
}
