#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <cmath>
#define endl '\n'
using namespace std;

const int MAXP = 10000000;

bool e[MAXP + 5];
vector<int> primes;
pair<long long, int> active[2][6000];

void sieve()
{
    e[1] = true;
    for (int i = 2; i <= MAXP; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAXP; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    sieve();
    primes.push_back(MAXP + 1);
    int sz = primes.size();

    int q;
    cin >> q;

    while (q--)
    {
        long long n;
        cin >> n;

        long long cnt = 0, wh = 0;
        for (int i = 0; i < sz - 1; ++ i)
        {
            int p = primes[i], q = primes[i + 1];
            long long t = 1ll * p * p;
            if (t <= n)
            {
                long long d = n / t + 1;
                if (1ll * q * q < d) active[0][wh++] = {t, p};
                cnt += n / t;
            }
        }

        int c = -1, curr = 1, prv = 0;
        ///int loops = 0;
        while (wh)
        {
            int wh1 = 0;
            for (int i = 0; i < wh; ++ i)
            {
                long long num1 = active[prv][i].first;
                int num2 = active[prv][i].second;
                int pos = lower_bound(primes.begin(), primes.end(), num2 + 1) - primes.begin();
                for (int j = pos; j < sz - 1; ++ j)
                {
                    int p = primes[j], q = primes[j + 1];
                    long long d = n / (1ll * p * p);
                    if (num1 > d) break;
                    if (num1 % p == 0) continue;
                    long long t = 1ll * num1 * p * p;
                    d = n / t + 1;
                    if (1ll * q * q < d) active[curr][wh1++] = {t, p};
                    cnt += c * n / t;
                }
            }
            c *= -1;
            curr ^= 1;
            prv ^= 1;
            wh = wh1;
            ///loops++;
        }
        ///cout << loops << endl;

        cout << n - cnt << endl;
    }

    return 0;
}
