#include <bits/stdc++.h>
using namespace std;

int n, q;
const int MAXN = 501;
const int MAXS = 250001;
int a[MAXN];
vector<int>join;
bool fl[MAXS];

struct Node{
    int l, r;
    Node *ld, *rd;
    vector<int> s;
    bool fl[MAXS];
    Node(int l, int r) {
        this->l = l;
        this->r = r;
    }
};

void Build(Node *k) {
    if(k->l == k->r) {
        k->ld = NULL; k->rd = NULL;
        k->s.push_back(a[k->l]);
        return;
    }
    k->ld = new Node(k->l, (k->l+k->r)/2);
    k->rd = new Node((k->l+k->r)/2+1, k->r);
    Build(k->ld);
    Build(k->rd);
    for(int i=0;i<k->ld->s.size();i++)
        if(!k->fl[k->ld->s[i]]) {
            k->fl[k->ld->s[i]] = 1;
            k->s.push_back(k->ld->s[i]);
        }
    for(int i=0;i<k->rd->s.size();i++)
        if(!k->fl[k->rd->s[i]]) {
            k->fl[k->rd->s[i]] = 1;
            k->s.push_back(k->rd->s[i]);
        }
    for(int i=0;i<k->ld->s.size();i++)
        for(int j=0;j<k->rd->s.size();j++)
            if(!k->fl[(k->ld->s[i])+(k->rd->s[j])]) {
                k->fl[(k->ld->s[i])+(k->rd->s[j])] = 1;
                k->s.push_back((k->ld->s[i])+(k->rd->s[j]));
            }
}

void Find(Node *k, int ll, int rr, int a, int b) {
    if(k->r < ll || rr < k->l) return;

    if(ll <= k->l && k->r <= rr) {
        vector<int> neww;
        for(int i=0;i<k->s.size();i++) neww.push_back(k->s[i]);
        for(int i=0;i<k->s.size();i++) {
            for(int j=0;j<join.size();j++) {
                neww.push_back((k->s[i])+(join[j]));
            }
        }
        for(int i=0;i<neww.size();i++)
            if(!fl[neww[i]]) {
                fl[neww[i]] = 1;
                join.push_back(neww[i]);
            }
        return;
    }
    Find(k->ld, ll, rr, a, b);
    Find(k->rd, ll, rr, a, b);

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int i, s = 0;
    cin>>n>>q;
    for(i=1;i<=n;i++) cin>>a[i], s+= a[i];

    Node *root = new Node(1, n);
    Build(root);

    while(q-- ) {
        int l, r, a, b;
        cin>>l>>r>>a>>b;
        join.clear();
        fill(fl, fl+s+1, 0);
        Find(root, l, r, a, b);
        int ll = lower_bound(join.begin(), join.end(), a) - join.begin();
        int rr = upper_bound(join.begin(), join.end(), b) - join.begin();
        cout<<rr-ll<<'\n';
    }

    return 0;
}
