#include <bits/stdc++.h>
#define endl "\n"
#define llong long long
using namespace std;

const llong maxn = 1e+14+14;
const llong smaxn = 1e+7+7;
llong q, n;

vector<llong> primes;
llong counts[smaxn];

bool not_prime[smaxn], not_free[smaxn];

void gen();
llong bprime(const llong& n);
llong bprime_index(const llong& n);

int main()
{
    // freopen("square_free.txt", "r", stdin);
    gen();
    cin >> q;
    for(llong i = 0; i < q; i++)
    {
        // cout << "hmm: the sequel" << endl;
        cin >> n;
        cout << counts[n] << endl;
    }
    return 0;
}

void gen()
{
    memset(not_free, 0, sizeof(not_free));
    llong ii = 1;
    counts[1] = 1;
    for(llong i = 2; i < smaxn; i++)
    {
        counts[i] = counts[i-1] + (not_free[i] ? 0 : 1);
        if (not_prime[i]) continue;
        primes.emplace_back(i);
        ii = i * i;
        for(llong j = (i<<1); j < smaxn; j+=i) not_prime[j] = true;
        for(llong j = ii; j < smaxn; j+=ii) not_free[j] = true;
    }
    // cout << "hmm" << endl;
}

llong bprime(const llong& n)
{
    return *(--upper_bound(primes.begin(), primes.end(), n));
}
llong bprime_index(const llong& n)
{
    return (--upper_bound(primes.begin(), primes.end(), n))-primes.begin();
}
