void set_memory(int index, unsigned int value);
unsigned int get_memory(int index);

//#include "pravetz.h"

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
using namespace std;

#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

int N;

bool already_sorted(int l, int r) {
    int last = get_memory(l);
    for(int i = l + 1; i <= r; i ++) {
        int now = get_memory(i);
        if(last > now) {
            return false;
        }
        last = now;
    }
    return true;
}

bool sort(int l, int r) {
    if(l == r) {
        return true;
    }
    if(already_sorted(l, r)) {
        return true;
    }
    int m = (l + r) / 2ll;

    bool flag = sort(l, m) & sort(m + 1, r);

    if(!flag) {
        return false;
    }


    int ptrl = l;
    int ptrr = m + 1;
    int lastl = get_memory(l);
    int lastr = get_memory(m + 1);

    const auto upl = [&]() {
        ptrl ++;
        if(ptrl == m + 1) {
            lastl = mod;
        } else {
            lastl = get_memory(ptrl);
        }
    };

    const auto upr = [&]() {
        ptrr ++;
        if(ptrr == r + 1) {
            lastr = mod;
        } else {
            lastr = get_memory(ptrr);
        }
    };

    int i = 0;
    while(ptrl != m + 1 || ptrr != r + 1) {
        if(lastl < lastr) {
            set_memory(N + i, lastl);
            upl();
        } else {
            set_memory(N + i, lastr);
            upr();
        }
        i ++;
    }

    for(int i = l; i <= r; i ++) {
        set_memory(i, get_memory(N + i - l));
    }

    return false;
}

bool sort_array(int n, bool start) {
    N = n;
    return sort(0, n - 1);
}

/// Tova e prekrasno, nali?
