#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const ll MAX_N = 1e7 + 10;
const ll MAX_NN = 1e14 + 10;
bool prime[MAX_N];
bool bad[MAX_N];
bool par[MAX_N];
vector<pair<ll, ll> > cool;
ll pref[MAX_N];

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cool.push_back({1, 1});
    for(ll i = 2; i < MAX_N; i ++) {
        if(prime[i]) {
            if(!bad[i]) {
                if(par[i]) {
                    cool.push_back({i * i, -1});
                } else {
                    cool.push_back({i * i, 1});
                }
            }
            continue;
        }

        par[i] = 1;
        cool.push_back({i * i, -1});

        for(ll j = i * 2; j < MAX_N; j += i) {
            prime[j] = true;
            par[j] ^= 1;
        }
        for(ll j = i * i; j < MAX_N; j += i * i) {
            bad[j] = true;
        }
    }

    const ll SMALL = 10001;

    for(ll i = 0; i < cool.size(); i ++) {
        if(i == 0) {
            pref[i] = cool[i].second;
        } else {
            pref[i] = cool[i].second + pref[i - 1];
        }
    }

    ll q = 125;
    cin >> q;
    while(q --) {
        ll n = 100000000000000;
        cin >> n;
        ll ret = 0;
        for(ll i = 0; i < cool.size() && n / cool[i].first >= SMALL; i ++) {
            ret += n / cool[i].first * cool[i].second;
        }
        for(ll i = 1; i < SMALL; i ++) {
            auto it = upper_bound(cool.begin(), cool.end(), pair<ll, ll>(n / i, 2)) - cool.begin();
            if(it == 0) { continue; }
            ret += pref[it - 1];
        }
        cout << ret << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?

//60792710185947
