#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const int MAX_N = 510;
const int MAX_Q = 1e6 + 10;
const int MAX_VAL = 3e5 + 10;
int arr[MAX_N], n, q;
pair<int, int> ab[MAX_Q];
vector<int> quer[MAX_N][MAX_N];

struct node {
    int sum, lazy;

    node() {}

    node operator +(const node &oth) {
        node ret;
        ret.sum = sum + oth.sum;
        return ret;
    }
};

struct seg_tree {
    node tree[4 * MAX_VAL];

    void push(int curr, int l, int r) {
        if(!tree[curr].lazy) { return; }
        tree[curr].sum = 0;
        if(l != r) {
            tree[curr * 2].lazy = true;
            tree[curr * 2 + 1].lazy = true;
        }
        tree[curr].lazy = false;
    }

    void upd(int curr, int l, int r, int ind) {
        push(curr, l, r);
        if(l == r && l == ind) {
            tree[curr].sum ++;
            return;
        } else if(l > ind || r < ind) { return; }
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind);
        upd(curr * 2 + 1, m + 1, r, ind);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }

    int sum(int curr, int l, int r, int ql, int qr) {
        push(curr, l, r);
        if(ql <= l && r <= qr) {
            return tree[curr].sum;
        } else if(l > qr || r < ql) { return 0; };
        int m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void reset() {
        tree[1].lazy = true;
    }
};

int ans[MAX_Q];

seg_tree st;
bitset<MAX_VAL> on, t, new_vals;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    for(int i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    for(int i = 0; i < q; i ++) {
        int l, r, a, b;
        cin >> l >> r >> a >> b;
        quer[l - 1][r - 1].push_back(i);
        ab[i] = {a, b};
    }

    for(int l = 0; l < n; l ++) {
        on.reset();
        st.reset();
        on[0] = 1;
        st.upd(1, 0, MAX_VAL - 1, 0);
        for(int r = l; r < n; r ++) {
            for(int i = MAX_VAL - 1; i >= arr[r]; i --) {
                if(!on[i] && on[i - arr[r]]) {
                    on[i] = true;
                    st.upd(1, 0, MAX_VAL - 1, i);
                }
            }
            for(const auto ind : quer[l][r]) {
                ans[ind] = st.sum(1, 0, MAX_VAL - 1, ab[ind].first, ab[ind].second);
            }
        }
    }

    for(int i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?
