#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
using namespace std;
#define endl '\n'
const int MAXN=5e2+1;
const int MAXS=2e5+5e4+2;
struct Query {
    int ind, a, b;
};
int a[MAXN], pref[MAXN];
bitset <MAXS> sums;
vector <Query> v[MAXN][MAXN];
long long ans[MAXN], cnt[MAXN];
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, q;
    cin >> n >> q;
    for (int i=1;i<=n;i++) {
        cin >> a[i];
        pref[i]=pref[i-1]+a[i];
    }
    int l, r, s1, s2;
    Query cur;
    for (int i=0;i<q;i++) {
        cin >> l >> r >> s1 >> s2;
        s2=min(s2,pref[r]-pref[l-1]);
        if (s1>pref[r]-pref[l-1]) ans[i]=0;
        else {
            cur.a=s1;
            cur.b=s2;
            cur.ind=i;
            v[l][r].push_back(cur);
        }
    }
    sums[0]=1;
    for (int i=1;i<=n;i++) {
        for (int j=1;j<=pref[n]-pref[i-1];j++) sums[j]=0;
        for (int j=i;j<=n;j++) {
            sums=(sums|(sums<<a[j]));
            cnt[0]=0;
            for (int p=1;p<=pref[j]-pref[i-1];p++) {
                cnt[p]=cnt[p-1]+sums[p];
            }
            for (int p=0;p<v[i][j].size();p++) {
                cur=v[i][j][p];
                ans[cur.ind]=cnt[cur.b]-cnt[cur.a-1];
            }
        }
    }
    for (int i=0;i<q;i++) cout << ans[i] << endl;
    return 0;
}
/**
5 3
12 3 4 6 8
2 4 6 15
1 5 1 1000
1 4 6 15
**/
