#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

const long long maxn = 1e7+1;
bool sqrFree[maxn];
bool primes[maxn];
int currnum[maxn];

vector <long long> primessqr;

void eratosten()
{
    for(long long i=2; i<=maxn; i++)
    {
        if(!primes[i])
        {
            for(int j=i*2; j<=maxn; j++)
            {
                primes[j]=true;
            }
            primessqr.push_back(i*i);
        }
    }
}


void eratostenSqr()
{

    for(int i=0; i<primessqr.size(); i++)
    {
        for(int j=primessqr[i];  j<=maxn; j+=primessqr[i])
        {
            sqrFree[j]=true;
        }
    }
}


int main()
{
    int q;
    cin >> q;
    long long n;

    eratosten();
    eratostenSqr();

    for(int i=1; i<=maxn; i++)
    {
        currnum[i]=currnum[i-1];
        if(!sqrFree[i])
        {
            currnum[i]++;
        }
    }

    long long answer;
    int j;
    long long i;
    bool check=false;
    for(int k=0; k<q; k++)
    {
        cin >> n;
        answer=0;
        if(n>(maxn-1))
        {
            answer=currnum[maxn-1];
            for(i=maxn; i<=n; i++)
            {
                check=false;
                for(j=0; j<primessqr.size(); j++)
                {
                    if(i%primessqr[j]==0)
                    {
                        check=true;
                        break;
                    }
                }
                if(!check)
                {
                    answer++;
                }
            }
        }
        else
        {
            answer=currnum[n];
        }
        cout << answer;
    }




    return 0;
}
