#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e7 + 10, maxq = 512;
int lp[maxn];
vector<int>primes;
int ans[maxn];
pair<int,int>a[maxq];
void gen_lcp(){
    lp[1] = 0;
    for (int i = 2;i <= maxn; ++i){
        if (lp[i] == 0){
            lp[i]=i;
            primes.push_back(i);
        }

        for (int j = 0; j < primes.size() && primes[j] <= lp[i] && primes[j]*i < maxn; ++j)
            lp[i*primes[j]]=primes[j];
    }
    /*for (int i =1; i <= 10; ++i)
        cout <<i << " " << lp[i] << endl;*/
}
bool check(int n){
    int prev = -1;
    while(lp[n] != 0){
        if (lp[n] == prev) return false;
        prev = lp[n];
        n /= lp[n];
    }
    return true;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    gen_lcp();
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i){
        cin >> a[i].first;
        a[i].second = i;
    }
    sort(a, a+q);
    for (int i = 1; i <= maxn; ++i){
        static int cnt = 0, ap = 0;
        if (check(i)){
            cnt++;
            /*if (i <= 10)
                cout << i << endl;*/
        }
        if (a[ap].first == i){
            ans[a[ap].second]=cnt;
            ap++;
        }
    }
    for (int i = 0; i <q; ++i)
        cout<<ans[i]<<endl;
    return 0;
}
