#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e7 + 10, maxq = 512;
int n = maxn - 10, lp[maxn], par[maxn];
vector<int>primes;
int ans[maxn];
int a[maxq];
void gen_lcp(){
    lp[1] = 0;
    for (int i = 2;i <= n; ++i){
        if (lp[i] == 0){
            lp[i]=i;
            primes.push_back(i);
        }

        for (int j = 0; j < primes.size() && primes[j] <= lp[i] && primes[j]*i <= n; ++j)
            lp[i*primes[j]]=primes[j];
    }
    /*for (int i =1; i <= 10; ++i)
        cout <<i << " " << lp[i] << endl;*/
}
bool check(int n){
    int prev = -1;
    while(lp[n] != 0){
        if (lp[n] == prev) return false;
        prev = lp[n];
        n /= lp[n];
    }
    return true;
}
void precompute(){
    for (int i = 1; i <= n; ++i)
        par[i]=par[i-1]+check(i);
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    gen_lcp();
    for (int i = 1; i <= n; ++i)
        par[i]=par[i-1]+check(i);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i){
        cin >> a[i];
        cout << par[a[i]] << endl;
    }
    return 0;
}
