#include<bits/stdc++.h>
#define MAXN 507
#define MAXS 100007
using namespace std;

struct event{
    int pos;
    int id;
    int type;
};

int n,q,ans[MAXN],l,r,a,b,s;
int c[MAXN],br;
vector<event> v[MAXN][MAXS];

int dp[MAXN][MAXS];
bool li[MAXN][MAXS];

int fenwick[MAXS];

void update(int x){
    if(x==0){
        br++;
        return;
    }
    while(x<=s){
        fenwick[x]++;
        x+=(x & (-x));
    }
}

int getsum(int x){
    int res=0;
    while(x>=1){
        res+=fenwick[x];
        x-=(x & (-x));
    }
    return res+br;
}

int ff(int pos,int sum){
    if(sum<0 or pos==-1)return 0;
    if(sum==0)return pos+1;

    if(li[pos][sum])return dp[pos][sum];
    li[pos][sum]=true;

    dp[pos][sum]=max(ff(pos-1,sum),ff(pos-1,sum-c[pos]));
    return dp[pos][sum];
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>c[i];
        s+=c[i];
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r>>a>>b;
        b=min(b,s);
        v[r][a-1].push_back({l-1,i,0});
        v[r][b].push_back({l-1,i,1});
    }

    for(int i=1;i<=n;i++){
        for(int f=0;f<=s;f++)fenwick[f]=0;
        br=0;

        for(int f=0;f<=s;f++){
            update(ff(i,f));
            for(int k=0;k<v[i][f].size();k++){
                if(v[i][f][k].type==0){
                    ans[v[i][f][k].id]=f+1-getsum(v[i][f][k].pos);
                }else{
                    ans[v[i][f][k].id]=f+1-getsum(v[i][f][k].pos)-ans[v[i][f][k].id];
                }
            }
        }
    }

    for(int i=1;i<=q;i++){
        cout<<ans[i]<<"\n";
    }

    return 0;
}
