#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
using namespace std;

const int bucket=50;

struct event{
    int pos;
    int id;
    int type;
};

struct query{
    int l,r,a,b,id;

    inline friend bool operator < (query fr,query sc){
        return fr.r<sc.r;
    }
};

int n,q,ans[1500007],l,r,a,b,s,pt,raz;
int c[507],br,cnt[507],toadd[507];
vector<query> w;
vector<event> v[250007];
unordered_set<int> z;
vector<int> curr;

int dp[2][250007];
int fenwick[250007];

void calc_dp(int pos){
    dp[pos%2][0]=pos+1;
    for(int sum=1;sum<=s;sum++){
        if(sum>=c[pos])dp[pos%2][sum]=max(dp[1-pos%2][sum],dp[1-pos%2][sum-c[pos]]);
        else dp[pos%2][sum]=dp[1-pos%2][sum];
    }
}

void update(int x,int val){
    if(x==0){
        br+=val;
        return;
    }
    while(x<=n){
        fenwick[x]+=val;
        x+=(x & (-x));
    }
}

void push_updates(){
    if(raz<=bucket){
        for(int i:curr){
            update(i,1);
            cnt[i]=0;
        }
    }else{
        br+=cnt[0];
        for(int i=1;i<=n;i++){
            toadd[i]+=cnt[i];
            fenwick[i]+=toadd[i];
            toadd[i+(i&(-i))]+=toadd[i];
        }
        for(int i=1;i<=n;i++){
            cnt[i]=toadd[i]=0;
        }
    }
    curr.clear();
    raz=0;
}

void add(int x){

}

int getsum(int x){
    int res=0;
    while(x>=1){
        res+=fenwick[x];
        x-=(x & (-x));
    }
    return res+br;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>c[i];
        s+=c[i];
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r>>a>>b;
        b=min(b,s);
        w.push_back({l,r,a,b,i});
    }
    sort(w.begin(),w.end());

    dp[0][0]=1;

    for(int i=1;i<=n;i++){
        for(int f=0;f<=s;f++){
            fenwick[f]=0; v[f].clear();
        }
        br=0;
        calc_dp(i);

        while(pt<q and w[pt].r==i){
            v[w[pt].a-1].push_back({w[pt].l-1,w[pt].id,0});
            v[w[pt].b].push_back({w[pt].l-1,w[pt].id,1});
            pt++;
        }

        for(int f=0;f<=s;f++){
            cnt[dp[i%2][f]]++;
            if(cnt[dp[i%2][f]]==1)raz++;
            if(raz<=bucket)curr.push_back(dp[i%2][f]);

            if(!v[f].empty())push_updates();

            for(int k=0;k<v[f].size();k++){
                if(v[f][k].type==0){
                    ans[v[f][k].id]=f+1-getsum(v[f][k].pos);
                }else{
                    ans[v[f][k].id]=f+1-getsum(v[f][k].pos)-ans[v[f][k].id];
                }
            }
        }
        push_updates();
    }

    for(int i=1;i<=q;i++){
        cout<<ans[i]<<"\n";
    }

    return 0;
}

