#include<bits/stdc++.h>
#pragma GCC optimize ("O3")
#pragma GCC target ("sse4")
using namespace std;

struct event{
    int pos;
    int id;
    int type;
};

struct query{
    int l,r,a,b,id;

    inline friend bool operator < (query fr,query sc){
        return fr.r<sc.r;
    }
};

int n,q,ans[1500007],l,r,a,b,s,pt;
int c[507],br,cnt[507],id[250007];
vector<int> curr,news;
vector<query> w;
vector<event> v[250007];

int dp[2][250007];

void calc_dp(int pos){
    dp[pos%2][0]=pos+1;
    for(int sum=1;sum<=s;sum++){
        if(sum>=c[pos])dp[pos%2][sum]=max(dp[1-pos%2][sum],dp[1-pos%2][sum-c[pos]]);
        else dp[pos%2][sum]=dp[1-pos%2][sum];
    }
}

int tree[1000007];

void build(int v,int l,int r){
    if(l==r){
        id[l]=v;
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
    }
}

int getsum(int v,int l,int r,int ll,int rr){
    if(ll>rr)return 0;
    if(l==ll and r==rr){
        return tree[v];
    }else{
        int tt=(l+r)/2;
        return getsum(2*v,l,tt,ll,min(tt,rr)) + getsum(2*v+1,tt+1,r,max(tt+1,ll),rr);
    }
}

void update(int v,int l,int r,int pos,int val){
    if(l==r){
        tree[v]+=val;
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos,val);
        else update(2*v+1,tt+1,r,pos,val);
        tree[v]=tree[2*v]+tree[2*v+1];
    }
}

void push_updates(){
    for(int i:curr){
        //tree[id[i]]+=cnt[i];
        update(1,0,s,i,cnt[i]);
        cnt[i]=0;
    }
    
    /*
    for(int i=0;i<curr.size();i++){
        curr[i]=id[curr[i]];
    }

    while(curr.size()!=1){
        news.clear();

        for(int f:curr){
            if(f%2==0)tree[f/2]=tree[f]+tree[f+1];
            else tree[f/2]=tree[f]+tree[f-1];
            cnt[f/2]++;
            if(cnt[f/2]==1){
                news.push_back(f/2);
            }
        }
        curr=news;
        for(int f:curr){
            cnt[f]=0;
        }
    }
    curr.clear();
    */
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>c[i];
        s+=c[i];
    }
    for(int i=1;i<=q;i++){
        cin>>l>>r>>a>>b;
        b=min(b,s);
        w.push_back({l,r,a,b,i});
    }
    sort(w.begin(),w.end());

    dp[0][0]=1;
    build(1,0,s);

    for(int i=1;i<=n;i++){
        for(int f=0;f<=s;f++){
            v[f].clear();
        }
        for(int f=0;f<=4*s;f++){
            tree[f]=0;
        }

        br=0;
        calc_dp(i);

        while(pt<q and w[pt].r==i){
            v[w[pt].a-1].push_back({w[pt].l-1,w[pt].id,0});
            v[w[pt].b].push_back({w[pt].l-1,w[pt].id,1});
            pt++;
        }

        for(int f=0;f<=s;f++){
            //cnt[dp[i%2][f]]++;
            //if(cnt[dp[i%2][f]]==1)curr.push_back(dp[i%2][f]);
            //if(!v[f].empty())push_updates();
            update(1,0,s,dp[i%2][f],1);
            
            for(int k=0;k<v[f].size();k++){
                if(v[f][k].type==0){
                    ans[v[f][k].id]=f+1-getsum(1,0,s,0,v[f][k].pos);
                }else{
                    ans[v[f][k].id]=f+1-getsum(1,0,s,0,v[f][k].pos)-ans[v[f][k].id];
                }
            }
        }
    }

    for(int i=1;i<=q;i++){
        cout<<ans[i]<<"\n";
    }

    return 0;
}
