#include<iostream>
#include<algorithm>
#include<vector>
#define endl '\n'
using namespace std;
int n,q,val[505];
vector<int> tree[2005];
void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node].push_back(0);
        tree[node].push_back(val[l]);
        return;
    }
    int mid=(l+r)/2;

    build(2*node,l,mid);
    build(2*node+1,mid+1,r);


    for(int i=0;i<tree[2*node].size();i++)
    {
        for(int j=0;j<tree[2*node+1].size();j++)
        {
            tree[node].push_back(tree[2*node][i]+tree[2*node+1][j]);
        }
    }

}
vector<int> query(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
        return tree[node];

    if(l>ri || r<le) return {0};

    int mid=(l+r)/2;

    vector<int> v1=query(2*node,l,mid,le,ri),v2=query(2*node+1,mid+1,r,le,ri),rez;

     for(int i=0;i<v1.size();i++)
    {
        for(int j=0;j<v2.size();j++)
        {
           rez.push_back(v1[i]+v2[j]);
        }
    }
    return rez;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;

    for(int i=1;i<=n;i++)
    {
        cin>>val[i];
    }
    build(1,1,n);

    int a,b,l,r,br=0;
    vector<int> t;
    for(int i=1;i<=q;i++)
    {
        cin>>l>>r>>a>>b;

        br=0;
        t=query(1,1,n,l,r);
        sort(t.begin(),t.end());
        for(int j=0;j<t.size();j++)
        {
            if(j!=0 && t[j]==t[j-1]) continue;

            if(t[j]>=a && t[j]<=b) br++;
        }
        cout<<br<<endl;
    }

}