#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int64_t MAXN = 1e7;

bool isComposite[MAXN+50];
vector <int64_t> primes;

void LinearSeave()
{
    for (int64_t i = 2; i <= MAXN; i++)
    {
        if (!isComposite[i])
            primes.push_back(i);

        for (int64_t p:primes)
        {
            if (p*i > MAXN)
                break;

            isComposite[p*i] = true;

            if (i%p == 0)
                break;
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    LinearSeave();

    int64_t q, n;
    cin >> q;

    for (int64_t i = 0; i < q; i++)
    {
        cin >> n;

        int64_t ans = n;

        for (int64_t j:primes)
        {
            if (j*j > n)
                break;

            ans -= n/(j*j);
        }

        cout << ans << endl;

    }
    return 0;
}
