#include<iostream>
#include<math.h>
#include<vector>
using namespace std;

const int MAXN=1e7+1;
bool sieve[MAXN];
bool hasSquare[MAXN];
long long ans[MAXN];
vector<long long> primes;

void GetPrimes(int n)
{
    for(int i=0; i<n; i++)
    {
        sieve[i]=0;
        hasSquare[i]=false;
    }

    for(int i=2; i<n; i++)
    {
        if(sieve[i]==0)
        {
            for(long long j=(long long)i*i; j<n; j+=i)
            {
                sieve[j]++;
            }

            for(long long j=(long long)i*i; j<n; j+=(long long)i*i)
            {
                hasSquare[j]=true;
            }
        }
    }

    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    GetPrimes(MAXN);
    ans[1]=1;
    for(int i=2; i<MAXN; i++)
    {
        ans[i]=ans[i-1];
        if(hasSquare[i])
        {
            continue;
        }

        ans[i]++;
    }

    int q;
    cin >> q;

    while(q--)
    {
        int n;
        cin >> n;

        cout << ans[n] << "\n";
    }

    return 0;
}
