#include <iostream>
#include <vector>

using namespace std;

typedef long long ll;

const ll maxN=10000000;

int q;
ll n;
vector<ll> ans;

void init()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    scanf("%d",&q);
}

bool sqn(ll x)
{
    ll i=2;
    while(i*i<=x)
    {
        if(x%(i*i)==0) return true;
        i++;
    }
    return false;
}

ll solve()
{
    return n*607926/1000000+1;

    ll ret=0;
    for(ll i=1;i<=n;i++)
        if(!sqn(i))
            ret++;
    return ret;
}

int main()
{
    init();
    for(int i=0;i<q;i++)
    {
        scanf("%lld",&n);
        ans.push_back(solve());
    }

    for(int i=0;i<q;i++)
        printf("%lld\n",ans[i]);
}
/*
  1 2 3   5 6 7
0 1   3 4 5   7   9
  1 2 3     6     9
0 1   3 4 5   7 8 9
  1 2 3     6 7
  1   3   5   7 8 9
*/
