#include<bits/stdc++.h>
#define pb push_back
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXS = 1e7 + 7;

vector<int> primes;
int min_pr[MAXS], cnt;

void init(){
    for(int d = 2; d < MAXS; d ++){
        if(min_pr[d] == 0){
            primes.pb(d);
            min_pr[d] = d;
        }
        for(int j = 0; j < primes.size() && primes[j] <= min_pr[d] && d * primes[j] < MAXS; j ++){
            min_pr[d * primes[j]] = primes[j];
            ++ cnt;
        }
    }
}

ll res(ll N){
    if(N <= 3) return N;
    ll ret = 0;
    for(auto x : primes){
        if(x * x > N) break;
        ret += res(N / (x * x));
    }
    cout << N << ": " << N - ret << endl;
    return N - ret;
}

int sq[MAXS];

int main(){
    init();
    vector<int> v;
    for(int d = 2; d * d < MAXS; d ++){
        v.pb(d * d);
    }
    for(auto x : v){
        for(int i = x; i < MAXS; i += x){
            sq[i] = 1;
        }
    }
    for(int i = 1; i < MAXS; i ++){
        sq[i] += sq[i - 1];
    }
    int Q; cin >> Q;
    for(int i = 0; i < Q; i ++){
        int N; cin >> N;
        cout << N - sq[N] << endl;
    }
}
