#include "pravetz.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <map>
#define endl '\n'
using namespace std;

unsigned int get_memory(int index);
void set_memory(int index, unsigned int value);

bool sort_array(int N, bool start)
{
    if (start)
    {
        int t = get_memory(1);
        set_memory(1, 1 * (1ll << 16) + t);
    }

    map<int, int> mp;

    int t0 = get_memory(0);
    mp[0] = t0;
    int t1 = get_memory(1);
    mp[1] = t1;
    int pos = t0 / (1ll << 16);
    int upto = t1 / (1ll << 16);

    for (int i = 1; i <= 1000; ++ i)
    {
        int val1 = (mp.count(pos) == 0 ? mp[pos] = get_memory(pos) : mp[pos]) % (1ll << 16);
        int val2 = (mp.count(upto) == 0 ? mp[upto] = get_memory(upto) : mp[upto]) % (1ll << 16);

        if (val1 > val2)
        {
            int x = mp[pos];
            set_memory(pos, x - val1 + val2);
            mp[pos] = x - val1 + val2;
            int y = mp[upto];
            set_memory(upto, y - val2 + val1);
            mp[upto] = y - val2 + val1;
        }

        t0 = mp[0];
        t1 = mp[1];

        upto++;
        if (upto == N)
        {
            pos++;
            upto = pos + 1;
            if (upto == N)
            {
                set_memory(0, t0 % (1ll << 16));
                set_memory(1, t1 % (1ll << 16));
                return true;
            }
        }
    }

    t0 = mp[0];
    t1 = mp[1];

    t0 = pos * (1ll << 16) + t0 % (1ll << 16);
    set_memory(0, t0);
    t1 = upto * (1ll << 16) + t1 % (1ll << 16);
    set_memory(1, t1);

    return false;
}
