#include "pravetz.h"
///#include "Lgrader.cpp"
#include <iostream>
#define endl '\n'
using namespace std;

unsigned int get_memory(int index);
void set_memory(int index, unsigned int value);

bool sort_array(int N, bool start)
{
    if (start)
    {
        int t = get_memory(1);
        set_memory(1, 1 * (1ll << 16) + t);
        return false;
    }

    int t0 = get_memory(0);
    int t1 = get_memory(1);
    int pos = t0 / (1ll << 16);
    int upto = t1 / (1ll << 16);
    int val1 = get_memory(pos) % (1ll << 16);
    int val2 = get_memory(upto) % (1ll << 16);

    if (pos >= N or upto >= N) return true;

    if (val1 > val2)
    {
        set_memory(pos, get_memory(pos) - val1 + val2);
        set_memory(upto, get_memory(upto) - val2 + val1);
    }

    t0 = get_memory(0);
    t1 = get_memory(1);

    upto++;
    if (upto == N)
    {
        pos++;
        upto = pos + 1;
        if (upto == N)
        {
            set_memory(0, t0 % (1ll << 16));
            set_memory(1, t1 % (1ll << 16));
            return true;
        }
    }

    t0 = pos * (1ll << 16) + t0 % (1ll << 16);
    set_memory(0, t0);
    t1 = upto * (1ll << 16) + t1 % (1ll << 16);
    set_memory(1, t1);

    return false;
}
