#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXP = 10000000;

bool e[MAXP + 5];
vector<int> primes;
long long n[505], cnt[505];
pair<long long, int> active[2][6000];

void sieve()
{
    e[1] = true;
    for (int i = 2; i <= MAXP; ++ i)
    {
        if (!e[i])
        {
            primes.push_back(i);
            for (long long j = 1ll * i * i; j <= MAXP; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    sieve();
    primes.push_back(MAXP + 1);
    int sz = primes.size();

    int q;
    cin >> q;

    long long N = 0;
    for (int i = 1; i <= q; ++ i)
    {
        cin >> n[i];
        N = max(N, n[i]);
    }

    int wh = 0;
    for (int i = 0; i < sz - 1; ++ i)
    {
        int p = primes[i], p1 = primes[i + 1];
        long long t = 1ll * p * p;
        if (t > N) break;
        long long d = N / t + 1;
        if (1ll * p1 * p1 < d) active[0][wh++] = {t, i};
        for (int j = 1; j <= q; ++ j)
        {
            cnt[j] += n[j] / t;
        }
    }

    int c = -1, curr = 1, prv = 0;
    ///int loops = 0;
    while (wh)
    {
        int wh1 = 0;
        for (int i = 0; i < wh; ++ i)
        {
            long long num = active[prv][i].first;
            int pos = active[prv][i].second + 1;
            for (int j = pos; j < sz - 1; ++ j)
            {
                int p = primes[j], p1 = primes[j + 1];
                long long d = N / (1ll * p * p);
                if (num > d) break;
                if (num % p == 0) continue;
                long long t = 1ll * num * p * p;
                d = N / t + 1;
                if (1ll * p1 * p1 < d) active[curr][wh1++] = {t, j};
                for (int k = 1; k <= q; ++ k)
                {
                    cnt[k] += c * n[k] / t;
                }
            }
        }
        c *= -1;
        curr ^= 1;
        prv ^= 1;
        wh = wh1;
        ///loops++;
    }
    ///cout << loops << endl;

    for (int i = 1; i <= q; ++ i)
    {
        cout << n[i] - cnt[i] << endl;
    }

    return 0;
}
