#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 500;
const int MAX = 1000000;

int x[MAXN + 5];
bool dp[MAX + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> x[i];
    }

    for (int i = 1; i <= q; ++ i)
    {
        int l, r, a, b;
        cin >> l >> r >> a >> b;

        for (int j = 0; j <= b; ++ j)
        {
            dp[j] = false;
        }

        dp[0] = true;
        int mx = 0;
        for (int j = l; j <= r; ++ j)
        {
            for (int k = x[j] + mx; k >= x[j]; -- k)
            {
                dp[k] |= dp[k - x[j]];
                if (dp[k]) mx = max(mx, k);
            }
        }

        int cnt = 0;
        for (int j = a; j <= b; ++ j)
        {
            if (dp[j]) cnt++;
        }
        cout << cnt << endl;
    }

    return 0;
}
