#include<ext/rope>
#include<iostream>
#include<cstdio>
#include<cmath>
#include<algorithm>
#include<cstdlib>
#include<iomanip>
#include<stack>
#include<queue>
#include<vector>
#include<set>
#include<map>
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC optimize("avx2")
#pragma GCC optimize("Ofast")
//using namespace __gnu_cxx;
using namespace std;
long long n,ans,a[501],q,MAX,A,B;
struct Node{
    long long b[250001];
    long long l,r;
    Node *ll, *rr;
    Node(){
        ll=rr=NULL;
    }
};
void calculate(Node* vr,long long l, long long r){
    int i,j,val;
    vr->b[0]=1;
    //for(i=0;i<=MAX;i++)cout<<vr->b[i]<<" "; cout<<endl;
    for(i=l;i<=r;i++){
        val=a[i];
        //cout<<"val="<<val<<endl;
        for(j=MAX;j>=val;j--)vr->b[j]+=vr->b[j-val];
    }
    for(i=1;i<=MAX;i++)vr->b[i]=vr->b[i-1]+min(vr->b[i],(long long)1);
    //for(i=0;i<=MAX;i++)cout<<vr->b[i]<<" "; cout<<endl;
}
void build(Node* vr, long long l, long long r){
    vr->l=l; vr->r=r;  //cout<<l<<" "<<r<<":\n";
    calculate(vr,l,r);
    if(l==r)return;
    vr->ll=new Node(); build(vr->ll,l,(l+r)/2);
    vr->rr=new Node(); build(vr->rr,(l+r)/2+1,r);
}
void rsq(Node *vr, long long l, long long r){
    if(vr->l==l && vr->r==r){
        //cout<<l<<" "<<r<<"; ";
        ans+=(vr->b[B]-vr->b[A-1]);
        return;
    }
    if(l<=vr->ll->r)rsq(vr->ll,l,min(r,vr->ll->r));
    if(r>=vr->rr->l)rsq(vr->rr,max(l,vr->rr->l),r);
}
Node* root=new Node();
int main(){
    int i,j,l,r;
    //ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin>>n>>q;
    for(i=1;i<=n;i++){scanf("%lld",&a[i]); MAX+=a[i];}
    build(root,1,n);
    for(i=0;i<q;i++){
        scanf("%lld %lld %lld %lld",&l,&r,&A,&B); ans=0;
        B=min(B,MAX); if(r<l){printf("0\n"); continue;}
        //cout<<A<<" "<<B<<endl;
        rsq(root,l,r); //cout<<endl;
        printf("%lld\n",ans);
    }
    return 0;
}
/*
1 1 1 2 3 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 25 26 27 27 27 28


5 15
12 3 4 6 8
2 4 6 15
1 5 1 1000
*/
