#include <bits/stdc++.h>
using namespace std;

int n, q;
const int MAXN = 501;
int a[MAXN];
set<int>::iterator it1, it2;
set<int> join;

struct Node{
    int l, r;
    Node *ld, *rd;
    set<int> s;
    Node(int l, int r) {
        this->l = l;
        this->r = r;
    }
};

void Build(Node *k) {
    if(k->l == k->r) {
        k->ld = NULL; k->rd = NULL;
        k->s.insert(a[k->l]);
        return;
    }
    k->ld = new Node(k->l, (k->l+k->r)/2);
    k->rd = new Node((k->l+k->r)/2+1, k->r);
    Build(k->ld);
    Build(k->rd);
    for(it1=k->ld->s.begin();it1!=k->ld->s.end();++it1)
        k->s.insert(*it1);
    for(it2=k->rd->s.begin();it2!=k->rd->s.end();++it2)
        k->s.insert(*it2);
    for(it1=k->ld->s.begin();it1!=k->ld->s.end();++it1) {
        for(it2=k->rd->s.begin();it2!=k->rd->s.end();++it2) {
            k->s.insert((*it1)+(*it2));
        }
    }
}

void Find(Node *k, int ll, int rr, int a, int b) {
    if(k->r < ll || rr < k->l) return;

    if(ll <= k->l && k->r <= rr) {
        vector<int> neww;
        for(it1=k->s.begin();it1!=k->s.end();++it1) neww.push_back(*it1);
        for(it1=k->s.begin();it1!=k->s.end();++it1) {
            for(it2=join.begin();it2!=join.end();++it2) {
                neww.push_back((*it1)+(*it2));
            }
        }
        for(int i=0;i<neww.size();i++) join.insert(neww[i]);
        return;
    }
    Find(k->ld, ll, rr, a, b);
    Find(k->rd, ll, rr, a, b);

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int i;
    cin>>n>>q;
    for(i=1;i<=n;i++) cin>>a[i];

    Node *root = new Node(1, n);
    Build(root);

  /*  while(q-- ) {
        int l, r, a, b;
        cin>>l>>r>>a>>b;
        join.clear();
        Find(root, l, r, a, b);
        vector<int> v;
        for(it1=join.begin();it1!=join.end();++it1) v.push_back(*it1);
        int ll = lower_bound(v.begin(), v.end(), a) - v.begin();
        int rr = upper_bound(v.begin(), v.end(), b) - v.begin();
        cout<<rr-ll<<'\n';
    }*/

    return 0;
}
