#include <bits/stdc++.h>
using namespace std;

int n, q;
const int MAXN = 501;
int a[MAXN];
vector<int>join;

struct Node{
    int l, r;
    Node *ld, *rd;
    vector<int> s;
    Node(int l, int r) {
        this->l = l;
        this->r = r;
    }
};

void Build(Node *k) {
    if(k->l == k->r) {
        k->ld = NULL; k->rd = NULL;
        k->s.push_back(a[k->l]);
        return;
    }
    k->ld = new Node(k->l, (k->l+k->r)/2);
    k->rd = new Node((k->l+k->r)/2+1, k->r);
    Build(k->ld);
    Build(k->rd);
    for(int i=0;i<k->ld->s.size();i++)
        k->s.push_back(k->ld->s[i]);
    for(int i=0;i<k->rd->s.size();i++)
        k->s.push_back(k->rd->s[i]);
    for(int i=0;i<k->ld->s.size();i++)
        for(int j=0;j<k->rd->s.size();j++)
            k->s.push_back((k->ld->s[i])+(k->rd->s[i]));
}

void Find(Node *k, int ll, int rr, int a, int b) {
    if(k->r < ll || rr < k->l) return;

    if(ll <= k->l && k->r <= rr) {
        vector<int> neww;
        for(int i=0;i<k->s.size();i++) neww.push_back(k->s[i]);
        for(int i=0;i<k->s.size();i++) {
            for(int j=0;j<join.size();j++) {
                neww.push_back((k->s[i])+(join[j]));
            }
        }
        for(int i=0;i<neww.size();i++) join.push_back(neww[i]);
        return;
    }
    Find(k->ld, ll, rr, a, b);
    Find(k->rd, ll, rr, a, b);

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int i;
    cin>>n>>q;
    for(i=1;i<=n;i++) cin>>a[i];

    Node *root = new Node(1, n);
    Build(root);

  /*  while(q-- ) {
        int l, r, a, b;
        cin>>l>>r>>a>>b;
        join.clear();
        Find(root, l, r, a, b);
        vector<int> v;
        for(it1=join.begin();it1!=join.end();++it1) v.push_back(*it1);
        int ll = lower_bound(v.begin(), v.end(), a) - v.begin();
        int rr = upper_bound(v.begin(), v.end(), b) - v.begin();
        cout<<rr-ll<<'\n';
    }*/

    return 0;
}
