#include <bits/stdc++.h>
#define endl "\n"
#define llong long long
using namespace std;

const llong maxn = 1e+14+14;
const llong smaxn = 1e+7+7;
llong q, n[smaxn], mn = 0;
llong counts[smaxn], iter = 1;

vector<llong> primes;
bool not_prime[smaxn];

void gen();
void solve();

int main()
{
    cin >> q;
    for(llong i = 0; i < q; i++)
    {
        cin >> n[i];
        if(mn < n[i]) mn = n[i];
    }
    gen();
    solve();
    return 0;
}

void gen()
{
    primes.emplace_back(2);
    for(llong i = 3; i <= mn; i++)
    {
        if (not_prime[i]) continue;
        primes.emplace_back(i);
        for(llong j = (i<<1); j <= mn; j+=i)
            not_prime[j] = true;
    }
}

void solve()
{
    bool success = false; llong square;
    iter = 1;
    for(llong i = 0; i < q; i++)
    {
        for(; iter <= n[i]; iter++)
        {
            counts[iter] = counts[iter-1];
            success = true;
            for(llong j = 0; j < primes.size(); j++)
            {
                square = primes[j] * primes[j];
                if(square > iter) break;
                if(iter % square == 0)
                { success = false; break; }
            }
            if(success) counts[iter]++;
        }
        cout << counts[n[i]] << endl;
    }
}

