#include "pravetz.h"

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

int N;

void sort(int l, int r) {
    if(l == r) {
        return;
    }
    int m = (l + r) / 2ll;
    sort(l, m);
    sort(m + 1, r);

    int ptrl = l;
    int ptrr = m + 1;
    int i = 0;

    while(ptrl != m + 1 && ptrr != r + 1) {
        int a = get_memory(ptrl);
        int b = get_memory(ptrr);
        if(a < b) {
            set_memory(N + i, a);
            ptrl ++;
        } else {
            set_memory(N + i, b);
            ptrr ++;
        }
        i ++;
    }

    while(ptrl != m + 1) {
        int a = get_memory(ptrl);
        set_memory(N + i, a);
        ptrl ++;
        i ++;
    }

    while(ptrr != r + 1) {
        int a = get_memory(ptrr);
        set_memory(N + i, a);
        ptrr ++;
        i ++;
    }

    for(int i = l; i <= r; i ++) {
        set_memory(i, get_memory(N + i - l));
    }
}

bool sort_array(int n, bool start) {
    N = n;
    bool flag = true;
    for(int i = 0; i < n - 1; i ++) {
        int a = get_memory(i);
        int b = get_memory(i + 1);
        if(a > b) {
            flag = false;
            set_memory(i, b);
            set_memory(i + 1, a);
        }
    }
    return flag;
}

/// Tova e prekrasno, nali?
