#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const ll MAX_N = 1e7 + 10;
bool prime[MAX_N];
vector<ll> primes;

map<ll, ll> dp;

ll ans(ll x) {
    if(x == 1) {
        return 1;
    } else if(x == 0) {
        return 0;
    } else if(dp.find(x) != dp.end()) {
        return dp[x];
    }

    ll ret = x;
    for(ll i = 0; i < primes.size() && primes[i] * primes[i] <= x; i ++) {
        ll start = x / primes[i] / primes[i];
        ret -= ans(start);
    }
    return dp[x] = ret;
}

signed main() {
    // ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    for(ll i = 2; i < MAX_N; i ++) {
        if(prime[i]) { continue; }
        primes.push_back(i);
        for(ll j = i * 2; j < MAX_N; j += i) {
            prime[j] = true;
        }
    }

    ll q;
    cin >> q;
    while(q --) {
        ll n;
        cin >> n;
        cout << ans(n) << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?

