#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const ll MAX_N = 310;
const ll MAX_Q = 1e6 + 10;
const ll MAX_VAL = 1e5 + 10;
ll arr[MAX_N], n, q;
pair<ll, ll> ab[MAX_Q];
vector<ll> quer[MAX_N][MAX_N];

struct seg_tree {
    int tree[4 * MAX_VAL];

    void upd(int curr, int l, int r, int ind) {
        while(true) {
            tree[curr] ++;
            if(l == r) { return; }
            int m = (l + r) / 2ll;
            if(ind <= m) {
                curr *= 2;
                r = m;
            } else {
                curr = curr * 2 + 1;
                l = m + 1;
            }
        }
    }

    ll sum(ll curr, ll l, ll r, ll ql, ll qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) { return 0; };
        ll m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void reset() {
        fill_n(tree, 4 * MAX_VAL, 0);
    }
};

ll ans[MAX_Q];

seg_tree st;
bitset<MAX_VAL> on, t, new_vals;

const ll WORD_SIZE = 64;
const ll BUCKETS = MAX_VAL / WORD_SIZE;
typedef unsigned long long bucket;
bucket bits[BUCKETS], new_bits[BUCKETS];

ll sum = 0;

void reset() {
    sum = 0;
    fill_n(bits, MAX_VAL / WORD_SIZE, 0);
    st.reset();
}

void perform(ll x) {
    sum += x;
    ll MX = sum / WORD_SIZE + 1;
    MX = BUCKETS;

    ll buck = x / WORD_SIZE;
    ll cntl = x % WORD_SIZE;
    ll cntr = WORD_SIZE - cntl;

    {
        new_bits[buck] = bits[0] << cntl;
        bucket nw = new_bits[buck] & ~bits[buck];
        while(nw > 0) {
            ll last = (nw == 1) ? 0 : __builtin_popcountll(~nw & (nw - 1));
            st.upd(1, 0, MAX_VAL - 1, buck * WORD_SIZE + last);
            nw -= (1ll << last);
        }
    }

    for(ll i = 1; i + buck < MX; i ++) {
        ll who = i + buck;
        new_bits[who] = (bits[i] << cntl) | (bits[i - 1] >> cntr);

        bucket nw = ~bits[who] & new_bits[who];
        while(nw > 0) {
            ll last = (nw == 1) ? 0 : __builtin_popcountll(~nw & (nw - 1));
            st.upd(1, 0, MAX_VAL - 1, who * WORD_SIZE + last);
            nw -= (1ll << last);
        }
    }

    for(ll i = 0; i + buck < MX; i ++) {
        bits[i] |= new_bits[i];
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    for(ll i = 0; i < q; i ++) {
        ll l, r, a, b;
        cin >> l >> r >> a >> b;
        quer[l - 1][r - 1].push_back(i);
        ab[i] = {a, b};
    }

    for(ll l = 0; l < n; l ++) {
        reset();
        bits[0] = 1;
        st.upd(1, 0, MAX_VAL - 1, 0);
        for(ll r = l; r < n; r ++) {
            perform(arr[r]);
            for(const auto ind : quer[l][r]) {
                ans[ind] = st.sum(1, 0, MAX_VAL - 1, ab[ind].first, ab[ind].second);
            }
        }
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?
