#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("sse4")
using namespace std;

#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
#define endl "\n"

template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

#define out(x) "[" << #x << "=" << x << "]"

template<class T> ostream &operator <<(ostream &out, const vector<T> &arr) {
    for(const auto &it : arr) { out << it << " "; }
    return out;
}

struct debug {
    debug(const string &out = "") { cerr << "DEBUGGER " << out <<  ": "; }
    ~debug() { cerr << endl; }

    template<class T>
    debug& operator <<(const T& a) {
        cerr << a << " ";
        return *this;
    }
};

#define dbg debug(to_string(__LINE__))
#define dbg_(x) debug(to_string(__LINE__) + "_" + x)

typedef long long ll;
const ll mod = 1e9 + 7;
///----------------------------------------------///

const int MAX_VAL = 1 << 18;
const int MAX_N = 510;
const int MAX_Q = 1e6 + 10;
int dp[MAX_VAL];
ll arr[MAX_N], n, q;
pair<ll, ll> ab[MAX_Q];
vector<ll> quer[MAX_N][MAX_N];
int ans[MAX_Q];

struct seg_tree {
    int tree[4 * MAX_VAL];

    void upd(int curr, int l, int r, int ind, int val) {
        while(true) {
            tree[curr] += val;
            if(l == r) { return; }
            int m = (l + r) / 2ll;
            if(ind <= m) {
                curr *= 2;
                r = m;
            } else {
                curr = curr * 2 + 1;
                l = m + 1;
            }
        }
    }

    ll sum(ll curr, ll l, ll r, ll ql, ll qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(l > qr || r < ql) { return 0; };
        ll m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }
} st;

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);

    cin >> n >> q;
    for(ll i = 0; i < n; i ++) {
        cin >> arr[i];
    }
    for(ll i = 0; i < q; i ++) {
        ll l, r, a, b;
        cin >> l >> r >> a >> b;
        quer[l - 1][r - 1].push_back(i);
        ab[i] = {a, b};
    }

    for(int j = 0; j < MAX_VAL; j ++)  {
        dp[j] = -mod;
    }

    int sum = 0;
    for(int i = 0; i < n; i ++) {
        dp[0] = i;
        sum += arr[i];
        for(int j = sum; j >= 0; j --) {
            if(dp[j] != -mod) chkmax(dp[j + arr[i]], dp[j]);
        }

        vector<ll> arr;
        for(int j = 0; j <= sum; j ++) {
            if(dp[j] != -mod) {
                arr.push_back((ll)dp[j] * mod + j);
                st.upd(1, 0, MAX_VAL - 1, j, 1);
            }
        }

        sort(arr.rbegin(), arr.rend());

        for(int l = 0; l <= i; l ++) {
            for(const auto ind : quer[l][i]) {
                ans[ind] = st.sum(1, 0, MAX_VAL - 1, ab[ind].first, ab[ind].second);
            }
            while(!arr.empty() && arr.back() / mod <= l) {
                st.upd(1, 0, MAX_VAL - 1, arr.back() % mod, -1);
                arr.pop_back();
            }
        }
    }

    for(ll i = 0; i < q; i ++) {
        cout << ans[i] << endl;
    }

    return 0;
}

/// Tova e prekrasno, nali?
