#include <bits/stdc++.h>
using namespace std;

unordered_map <long long, long long> dp;

long long square_br (long long a) {
    if (dp.find(a) != dp.end()) {
        return dp[a];
    }
    long long ans=0;
    for (long long A=2; A*A <= a; A++) {
        ans += int(a/A/A) - square_br(int(a/A/A));
    }
    dp.insert({a, ans});
    return ans;
}

long long square_free_br (long long a) {
    return a - square_br(a);
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

dp.insert({1,0});
dp.insert({2,0});
dp.insert({3,0});
dp.insert({4,1});
dp.insert({5,1});
dp.insert({6,1});
dp.insert({7,1});
dp.insert({8,2});
dp.insert({9,3});
dp.insert({10,3});

for (int i=11; i <= 1000000; i++) {
    long long k = square_br(k);
    dp.insert({i, k});
}

long long q, n;
cin >> q;

for (long long i=0; i < q; i++) {
    cin >> n;
    cout << square_free_br(n) << endl;
}

return 0;
}