#include <bits/stdc++.h>
using namespace std;

unordered_map <long long, long long> dp;

long long square_free_br (long long a) {
    if (dp.find(a) != dp.end()) {
        return dp[a];
    }
    long long ans=a - (long long)(a/4) - (long long)(a/9);
    for (long long A=6; A*A <= a; A+=(long long)6) {
        ans += square_free_br(a/A/A);
    }
    for (long long A=5; A*A <= a; A+=(long long)6) {
        ans -= square_free_br(a/A/A);
        ans -= square_free_br(a/(A+2)/(A+2));
    }
    dp.insert({a, ans});
    return ans;
}

int main () {
ios_base::sync_with_stdio(false);
cin.tie(0); cout.tie(0);

dp.insert({1,1});
dp.insert({2,2});
dp.insert({3,3});
dp.insert({4,3});
dp.insert({5,4});
dp.insert({6,5});
dp.insert({7,6});
dp.insert({8,6});
dp.insert({9,6});
dp.insert({10,7});

for (int i=11; i <= 1000; i++) {
    long long k = square_free_br(i);
    dp.insert({i, k});
}

long long q, n;
cin >> q;

for (long long i=0; i < q; i++) {
    cin >> n;
    cout << square_free_br(n) << endl;
}

return 0;
}