#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
#define endl '\n'
const int MAXN=1e7+1;
const int MAXM=7e5+10;
vector <long long> pr;
bool er[MAXN];
unordered_map <long long, long long> dp[MAXM];
void precomp() {
    for (long long i=2;i<MAXN;i++) {
        if (!er[i]) {
            pr.push_back(i*i);
            for (long long j=i*i;j<=MAXN;j+=i) er[j]=true;
        }
    }
}
long long find_dp(int ind, long long n) {
    if (ind==0) return n/pr[ind];
    if (dp[ind][n]!=0) return dp[ind][n];
    dp[ind][n]=n/pr[ind]-find_dp(ind-1,n/pr[ind])+find_dp(ind-1,n);
    ///cout << ind << ' ' << n << ' ' << dp[ind][n] << ' ' << pr[ind] << endl;
    return dp[ind][n];
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    precomp();
    cin >> q;
    long long n;
    for (int i=0;i<q;i++) {
        cin >> n;
        int l, r, mid;
        l=0; r=pr.size()-1;
        while (l<=r) {
            mid=(l+r)/2;
            if (pr[mid]>n) r=mid-1;
            else l=mid+1;
        }
        cout << n-find_dp(r,n) << endl;
    }
    return 0;
}

