#include <iostream>

#define endl '\n'

using namespace std;

const int MAXN = 1e7 + 3;
bool is_square[MAXN];
int counter[MAXN];

bool check_number(int num)
{
    for (int y = 2; 1ll * y * y <= 1ll * num; ++y)
    {
        if (num % (y * y) == 0)
        {
            return false;
        }
    }

    return true;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int q;
    cin >> q;

    for (int i = 2; 1ll * i * i < 1ll * MAXN; ++i)
    {
        for (int j = i * i; j < MAXN; j += (i * i))
        {
            is_square[j]= true;
        }
    }

    for (int i = 1; i < MAXN; ++i)
    {
        counter[i] = (!is_square[i]) + counter[i - 1];
    }

    for (int i = 0; i < q; ++i)
    {
        int n;
        cin >> n;

        cout << counter[n] << endl;
    }

    return 0;
}
