#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

const long long maxn = 1e7+1;
bool primes[maxn];
long long sum[15];
long long pow10[15];
vector <long long> primessqr;

void eratosten()
{
    for(long long i=2; i<=maxn; i++)
    {
        if(!primes[i])
        {
            for(int j=i*2; j<=maxn; j++)
            {
                primes[j]=true;
            }
            primessqr.push_back(i*i);
        }
    }
}


/*void eratostenSqr()
{

    for(int i=0; i<primessqr.size(); i++)
    {
        for(int j=primessqr[i];  j<=maxn; j+=primessqr[i])
        {
            sqrFree[j]=true;
        }
    }
}*/


int main()
{
    int q;
    cin >> q;
    long long n;

    eratosten();
    pow10[0]=1;
    for(int i=1; i<=14; i++)
    {
        sum[i]=sum[i-1]*10+6;
        pow10[i]=pow10[i-1]*10;
    }

    /*for(int i=1; i<=maxn; i++)
    {
        currnum[i]=currnum[i-1];
        if(!sqrFree[i])
        {
            currnum[i]++;
        }
    }*/

    long long answer;
    int j;
    long long i;
    bool check=false;
    int ind;
    for(int k=0; k<q; k++)
    {
        cin >> n;
        answer=0;
        for(int i=1; i<15; i++)
        {
            if(n<pow10[i])
            {
                ind=i-1;
                break;
            }
        }
        answer=sum[ind];
        //cout << answer << endl;
        for(long long i=pow10[ind]+1; i<=n; i++)
        {
            check=false;
            for(int j=0; j<primessqr.size(); j++)
            {
                if(i%primessqr[j]==0)
                {
                    check=true;
                }
            }
            if(!check)
            {
                answer++;
            }
        }
        cout << answer << endl;

    }




    return 0;
}
