#include <iostream>
#include <vector>
#include <unordered_set>
#define MAX_N 505
using namespace std;

unordered_set<int> table [MAX_N][MAX_N];
int notes[MAX_N];

void fill_nostes(int n)
{
    for(int i=1; i<=n; i++)
    {
        for(int j=i; j<=n; j++)
        {
            table[i][j].insert(notes[j]);
            //cout << i << " " << j << endl;
            for(auto v:table[i][j-1])
            {
                //cout << v << endl;
                table[i][j].insert(v);
                table[i][j].insert(notes[j]+v);
            }
        }
    }
}

int main()
{
    int n, q;
    cin >> n >> q;

    for(int i=1; i<=n; i++)
    {
        cin >> notes[i];
    }

    fill_nostes(n);

    int l, r, a, b;
    int counter;

    for(int k=0; k<q; k++)
    {
        cin >> l >> r >> a >> b;
        counter=0;
        for(auto v:table[l][r])
        {
            if(v<=b && v>=a)
            {
                counter++;
            }
        }
        cout << counter << endl;
    }

    return 0;
}
