#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 500 + 5;
const int MAXS = 90000 + 1;//250000 + 5;
const int MAXA = 2 * 1000000;
const int MAXQ = 1500000 + 5;
int arr[MAXN];

int n, q;

struct Query
{
    int l, r, a, b, num, ans;
};

Query qu[MAXQ];

bool cmp(Query a, Query b)
{
    if (a.l == b.l) return a.r < b.r;
    return a.l < b.l;
}

bool cmp2(Query a, Query b)
{
    return a.num < b.num;
}

int main ()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> q;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];

    for (int i = 1; i <= q; i++)
    {
        cin >> qu[i].l >> qu[i].r >> qu[i].a >> qu[i].b;
        qu[i].num = i;
    }
    sort(qu+1, qu+q+1, cmp);

    bitset <MAXS> bs;

    for (int Q = 1; Q <= q; Q++)
    {
        if (qu[Q].l == qu[Q-1].l)
        {
            for (int i = qu[Q-1].r+1; i <= qu[Q].r; i++)
            {
                bs |= (bs << arr[i]);
            }
        }
        else
        {
            bs.reset();
            bs[0] = 1;
            for (int i = qu[Q].l; i <= qu[Q].r; i++)
            {
                bs |= (bs << arr[i]);
            }
        }

        int a = min(qu[Q].a, MAXS-1);
        int b = min(qu[Q].b, MAXS-1);

//        cout << bs.to_string() << endl;

        int ans = 0;
        for (int i = a; i <= b; i++)
        {
            ans += bs[i];
        }
        qu[Q].ans = ans;
    }

    sort(qu+1, qu+q+1, cmp2);

    for (int i = 1; i <= q; i++)
        cout << qu[i].ans << endl;

    return 0;
}
/**

3 4
1 1 1
1 1 1 10
1 2 1 10
1 3 1 10
2 2 1 10

5 2
12 3 4 6 8
2 4 6 15
1 5 1 1000


*/
