#include<iostream>
#include<vector>
#include<tuple>
#include<cstring>
using namespace std;
const int MAX_N=5e2+2;
const int MAX=250000;
const int MAX_Q=1500002;
int n,q;
int a[MAX_N];
bool used[MAX_N*MAX_N];
vector<tuple<int,int,int>>que[MAX_N][MAX_N];
int ans[MAX_Q];
int tree[MAX_N*MAX_N];
void Update(int pos,int st)
{
    for(;;)
    {
        if(pos>MAX)break;
        tree[pos]+=st;
        pos+=((pos)&(-pos));
    }
}
int Find(int pos)
{
    int sum=0;
    for(;;)
    {
        if(pos<1)break;
        sum+=tree[pos];
        pos-=((pos)&(-pos));
    }
    return sum;
}
int main ()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>q;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    int l,r,aa,b;
    for(int i=1;i<=q;i++)
    {
       cin>>l>>r>>aa>>b;
       que[l][r].push_back({aa,b,i});
    }
    for(int i=1;i<=n;i++)
    {
        used[0]=1;
        vector<int>v;
        v.push_back(0);
        for(int j=i;j<=n;j++)
        {
            int sz=v.size();
            for(int id=0;id<sz;id++)
            {
                if(!used[v[id]+a[j]])
                {
                    v.push_back(v[id]+a[j]);
                    used[v[id]+a[j]]=1;
                    Update(v[id]+a[j],+1);
                }
            }
            for(auto [a,b,idx]:que[i][j])
            {
                ans[idx]=Find(b)-Find(a-1);
            }
        }
        for(int x:v)
        {
            used[x]=0;
            Update(x,-1);
        }
    }
    for(int i=1;i<=q;i++)
    {
        cout<<ans[i]<<"\n";
    }

    return 0;
}
