#include <bits/stdc++.h>

typedef long long ll;
typedef long  double ld;

const int MAX_N = 1e7 + 42;
const int mod = 1e9 + 7;
const int INF = 1e9;

std::vector<int> v;
bool oke[MAX_N];

std::mt19937 gen;
int randNum( int lb, int ub ){
    std::uniform_int_distribution<int> dist(lb, ub);
    return dist(gen);
}

ll inp;

bool viz[MAX_N];
ll slow( ){
    for( ll i = 2 ; i<=sqrt(inp) ; i++ ){
        if( viz[i] ) continue;
        for( ll curr = i*i ; curr <= inp ; curr += i*i ){
            viz[curr] = true;
        }
    }
    ll nas = 0;
    for( int i=1 ; i<=inp ; i++ ){
        if( !viz[i] ) nas ++;
    //    else std::cout<<i<<" , ";
    //    std::cout<<"--------------\n";
        viz[i] = false;
    }
    return nas;
}

int main (){

    std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);
    gen.seed(time(NULL));

    /*
    int br = 0;
    while( true ){
        inp = randNum( 10, 50 );
        ll n = inp;
        ll sq = sqrt(n);
        for( ll i = 2 ; i<=sq ; i++ ){
            if( oke[i] ) continue;
            v.push_back(i);
            for( ll j = (ll)i*i ; j <= sq ; j *= i ){
                oke[j] = true;
            }
        }

     //   for( auto j : v ) std::cerr<<j<<" ";
     //   std::cerr<<"\n\n";
        ll nas = n;
        for( ll j : v ) nas -= n/(j*j);
    //    std::cout<<nas<<"\n";
        if( nas != slow() ){
            std::cout<<inp<<"\n";
            std::cout<<slow()<<" "<<nas<<"\n";
            std::cout<<br<<"\n";
            return 0;
        }
        br ++;
        for( int i=0 ; i<sq ; i++ ) oke[i] = false;
        v.clear();

    }
*/
    int q;
    std::cin>>q;
    /*
    while( q-- ){
        std::cin>>inp;
        std::cout<<slow()<<"\n";
    }
    return 0;
    */

    while( q-- ){
        ll n;
        std::cin>>n;
        ll sq = sqrt(n);
        for( ll i = 2 ; i<=sq ; i++ ){
            if( oke[i] ) continue;
            v.push_back(i);
            for( ll j = (ll)i*i ; j <= sq ; j *= i ){
                oke[j] = true;
            }
        }

        for( ll j :v ){
            for( ll curr = j *j ; curr <= n ; curr += j*j ){
                viz[curr] = true;
            }
        }

        ll nas = 0;
        for( int i=1 ; i<=n ; i++ ){
            if( !viz[i] ){
                nas++;
                viz[i] = false;
            }
        }
        std::cout<<nas<<"\n";

        /*
        for( auto j : v ) std::cerr<<j<<" ";
        std::cerr<<"\n\n";

        ll nas = n;
        for( ll j : v ){
                nas -= n/(j*j);
                std::cerr<<" ! "<<j*j<<" "<<n/(j*j)<<"\n";
        }
        for( int j=0 ; j<v.size() ; j++ ){
            for( int j1 = j-1 ; j1>=0 ; j1-- ){
                ll a = v[j]*v[j];
                ll b = v[j1]*v[j1];
                ll nod = a*b/std::__gcd( a, b );
                std::cerr<<a<<" "<<b<<" -> "<<nod<<", "<<n/nod<<"\n";
                nas += n/nod;
            }
        }
        std::cout<<nas<<"\n";
        */
        for( int i=0 ; i<=inp ; i++ ) oke[i] = false;
        v.clear();
    }

    return 0;
}
