#include "pravetz.h"
#include <algorithm>
#include <iostream>
#include <numeric>

typedef long long llong;
const int MAXN = (1 << 16);
const int INF  = 1e9;

bool sort_array(int n, bool start)
{
    int num = get_memory(n);
    int step = get_memory(n) % (4*n);
    int bit = get_memory(n) / (4*n);
    if (step == 0)
    {
        set_memory(n, 0);
        set_memory(n + 1, 0);
    }
    if (step == 4 * n - 1)
    {
        set_memory(n, num + 1);
        return false;
    }

    if (bit == 16) return true;
    if (step < n)
    {
        int curr = get_memory(step) & (1 << bit);
        if (curr > 0)
        {
            int cnt = get_memory(n + 1);
            set_memory(n + 1, cnt + 1);
        }

        set_memory(n, num + 1);
        return false;
    }

    if (step < 2*n)
    {
        int curr = get_memory(n + 1);
        if (step == n && curr == n)
        {
            set_memory(n, num + 3 * n);
            return false;
        }

        int currNum = get_memory(n - 1 - (step - n));
        if (currNum & (1 << bit))
        {
            set_memory(curr + n + 1, currNum);
            set_memory(n + 1, curr - 1);
        }

        set_memory(n, num + 1);
        return false;
    }

    if (step < 3 * n)
    {
        int curr = get_memory(step - 2 * n) & (1 << bit);
        if (curr == 0)
        {
            int cnt = get_memory(n + 1);
            set_memory(cnt, get_memory(step - 2 * n));
            set_memory(n + 1, cnt + 1);
        }

        set_memory(n, num + 1);
        return false;
    }

    int curr = get_memory(n + 1);
    if (curr == n)
    {
        set_memory(n, num + 4 * n - step);
        return false;
    }

    int currNum = get_memory(n + 2 + step - 3 * n);
    if (currNum & (1 << bit))
    {
        set_memory(curr, currNum);
        set_memory(n + 1, curr + 1);
    }

    set_memory(n, num + 1);
    return false;
}
