#include <iostream>
#include "pravetz.h"
bool sort_array(int N, bool start) {
    const int base = 1024;
    if (start) {
        if (get_memory(0) < get_memory(1)) {
            set_memory(1, get_memory(1) + base);
        }
        set_memory(0, get_memory(0) + 2 * base);
        return false;
    }

    if (get_memory(0) >= base) {
        int curr = get_memory(0) / base;
        int max = get_memory(1) / base;
        if (curr == N) {
            set_memory(N - 1, get_memory(N - 1) + base * get_memory(max));
            set_memory(max, get_memory(N - 1) % base);
            set_memory(N - 1, get_memory(N - 1) / base);
            set_memory(0, get_memory(0) % base);
            set_memory(1, get_memory(1) % base);
            return false;
        }
        if (get_memory(curr) > get_memory(max)) {
            set_memory(1, (get_memory(1) % base) + base * curr);
        }
        set_memory(0, get_memory(0) + base);
        return false;
    } else {
        int curr = get_memory(N - 1) / base;
        if (curr == N - 2) {
            return true;
        }
        if (get_memory(curr) > get_memory(curr + 1)) {

            set_memory(curr, get_memory(curr) + base * get_memory(curr + 1));
            set_memory(curr + 1, get_memory(curr) % base);
            set_memory(curr, get_memory(curr) / base);

            set_memory(N - 1, std::max(get_memory(N - 1) - base, get_memory(N - 1)));
        } else {
            set_memory(N - 1, get_memory(N - 1) + base);
        }
        return false;
    }
    return false;
}
