#include <iostream>
using namespace std;
const long long MAXN = 1e7 + 1;
bool comp[MAXN], not_free[MAXN];
void solve() {
    long long n;
    cin >> n;
    long long ans = 0;
    for (long long curr = 1; curr <= n; curr++) {
        if (!not_free[curr]) {
            ans++;
        }
    }
    cout << ans << '\n';
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    for (long long curr = 2; curr * curr <= MAXN; curr++) {
        if (!comp[curr]) {
            for (long long i = curr * 2; i <= MAXN; i += curr) {
                comp[i] = true;
            }
            for (long long i = curr * curr; i <= MAXN; i += curr * curr) {
                not_free[i] = true;
            }
        }
    }

    int q;
    cin >> q;
    while (q --> 0) {
        solve();
    }
    return 0;
}
