#include<iostream>
#include<cmath>
using namespace std;
const int MAXN = 1e7+7;
bool prosti[MAXN];
long long kvadrati[MAXN];
int ind;
long long P;
long long tree[4*MAXN];
void build_tree(int l,int r,int ind){
    if(l==r){
        if(!prosti[l]) tree[ind]=1;
        return;
    }
    int m = (l+r)/2;
    build_tree(l,m,2*ind);
    build_tree(m+1,r,2*ind+1);
    tree[ind]=tree[2*ind]+tree[2*ind+1];
}
int query(int l,int r,int ind,int ql,int qr){
    if(ql<=l and r<=qr){
        return tree[ind];
    }
    int m = (l+r)/2;
    int ans = 0;
    if(ql<=m) ans+= query(l,m,2*ind,ql,qr);
    if(qr>m) ans+= query(m+1,r,2*ind+1,ql,qr);
    return ans;
}
int main(){
    //freopen(stdout,"w","kvadrati.txt");
    int N = 1e7 + 7;
    P = N;
    N = sqrt(P);
    for(long long i=2;i<=N;i++){
        if(!prosti[i]){
            kvadrati[ind]=i*i;
            ind++;
        }
        for(long long j=i*i;j<=N;j+=i){
            prosti[j]=true;
        }
    }
    fill(prosti,prosti+P,0);
    for(int i = 0 ; i < ind ; i++){
        for(long long q = kvadrati[i];q<=P;q+=kvadrati[0]){
            prosti[q]=true;
        }
    }
    build_tree(0,P-1,1);
    int q;
    cin>>q;
    while(q--){
        cin>>N;
        cout<<query(0,P-1,1,1,N)<<"\n";
    }
    return 0;
}

