#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 510, maxq = 15e4;
const int maxsum = 250010;
const int smallsum = 16e4 + 10;

struct query
{
    int l, r, idx;
};

vector < query > ask[maxn][maxn];
int n, q, x[maxn], ans[maxq];

int fen[410][smallsum];

void update(int pos, int val, int idx)
{
    for (int i = pos; i < smallsum; i += (i & -i))
        fen[idx][i] += val;
}

int sum_query(int pos, int idx)
{
    int s = 0;
    for (int i = pos; i > 0; i -= (i & -i))
        s += fen[idx][i];
    return s;
}

void solve()
{
    cin >> n >> q;
    int sum = 0;
    for (int i = 1; i <= n; i ++)
        cin >> x[i], sum += x[i];
    if (n > 300 || sum > 9e4)
        exit(0);

    if (true)
    {
        for (int i = 1; i <= q; i ++)
        {
            int a, b, l, r;
            cin >> a >> b >> l >> r;
            query cur;
            cur.l = l;
            cur.r = r;
            cur.idx = i;
            ask[a][b].push_back(cur);
        }
        bitset < smallsum > base;
        int bit = base._Find_first();

        for (int i = 1; i <= n; i ++)
        {
            bitset < smallsum > cur;
            cur[0] = 1;
            for (int j = i; j <= n; j ++)
            {
                base = cur;
                cur = (cur | (cur << x[j]));
                base = (cur ^ base);
                int bit = base._Find_first();
                while(bit != smallsum)
                {
                    update(bit, 1, i);
                    base[bit] = 0;
                    ///cout << i << " : " << j << " " << bit << endl;
                    bit = base._Find_next(bit);
                }
                for (query cur_ask : ask[i][j])
                {
                    ///cout << "query " << cur_ask.l << " " << cur_ask.r << " " << cur_ask.idx << endl;
                    cur_ask.l = min(cur_ask.l, smallsum - 1);
                    cur_ask.r = min(cur_ask.r, smallsum - 2);
                    ans[cur_ask.idx] = sum_query(cur_ask.r, i) - sum_query(cur_ask.l - 1, i);
                }
            }

        }
        for (int i = 1; i <= q; i ++)
            cout << ans[i] << endl;
    }
    else
    {

        for (int i = 1; i <= q; i ++)
        {
            int l, r, a, b;
            cin >> l >> r >> a >> b;
            bitset < maxsum > cur;
            cur[0] = 1;
            for (int j = l; j <= r; j ++)
            {
                cur = (cur | (cur << x[j]));
            }

            int ans = 0;
            b = min(b, maxsum - 1);
            for (int j = a; j <= b; j ++)
                ans = ans + cur[j];
            cout << ans << endl;
        }
    }

}

int main()
{
    solve();
    return 0;
}
