#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 510, maxq = 15e4;
const int maxsum = 250010;
const int smallsum = 16e4 ;

struct query
{
    int l, r, idx;
};

vector < query > ask[maxn][maxn];
int n, q, x[maxn], ans[maxq];

int block_sum[smallsum];
int pos_sum[smallsum], block_size;

int sum_query(int l, int r)
{
    int sum = 0;
    int start_block = (l / block_size) + 1;
    int end_block = (r / block_size) - 1;
    for (int block_index = start_block; block_index <= end_block; block_index ++)
        sum = sum + block_sum[block_index];
    if (start_block > end_block)
    {
        for (int i = l; i <= r; i ++)
            sum += pos_sum[i];
    }
    else
    {
        for (int i = l; i < start_block * block_size; i ++)
            sum += pos_sum[i];
        for (int i = (end_block + 1) * block_size; i <= r; i ++)
            sum += pos_sum[i];
    }
    //cout << l << " " << r << " : " << sum << endl;
    ///cout << block_size << " " << start_block << " " << end_block << endl;
    return sum;
}
void solve()
{
    cin >> n >> q;
    int sum = 0;
    for (int i = 1; i <= n; i ++)
        cin >> x[i], sum += x[i];
    //if (n > 300 || sum > 9e4)
    //  exit(0);

    if (n <= 300 && sum <= 9e4)
    {
        block_size = sqrt(sum) + 1;
        for (int i = 1; i <= q; i ++)
        {
            int a, b, l, r;
            cin >> a >> b >> l >> r;
            query cur;
            cur.l = l;
            cur.r = r;
            cur.idx = i;
            ask[a][b].push_back(cur);
        }
        bitset < smallsum > base;
        int bit = base._Find_first();
        bitset < smallsum > cur, zero_bit;
        for (int i = 1; i <= n; i ++)
        {
            ///cout << "reset" << endl;
            cur = (cur & zero_bit);
            for (int j = 0; j <= sum; j ++)
                block_sum[j] = pos_sum[j] = 0;
            cur[0] = 1;
            for (int j = i; j <= n; j ++)
            {
                base = cur;
                cur = (cur | (cur << x[j]));
                base = (cur ^ base);
                /** cout << "----------------" << endl;
                                 for (int j = 0; j < 20; j ++)
                     cout << cur[j] << " ";
                     cout << endl;
                 for (int j = 0; j < 20; j ++)
                     cout << base[j] << " ";
                     cout << endl;*/
                int bit = base._Find_first();
                while(bit != smallsum)
                {
                    block_sum[bit / block_size] ++;
                    pos_sum[bit] ++;
                    base[bit] = 0;
                    ///cout << i << " : " << j << " " << bit << endl;
                    bit = base._Find_next(bit);
                }
                for (query cur_ask : ask[i][j])
                {
                    ///cout << "query " << cur_ask.l << " " << cur_ask.r << " " << cur_ask.idx << endl;
                    cur_ask.l = min(cur_ask.l, smallsum - 1);
                    cur_ask.r = min(cur_ask.r, smallsum - 2);

                    ans[cur_ask.idx] = sum_query(cur_ask.l, cur_ask.r);
                }
            }

        }
        for (int i = 1; i <= q; i ++)
            cout << ans[i] << endl;
    }
    else
    { block_size = sqrt(sum) + 1;
        for (int i = 1; i <= q; i ++)
        {
            int a, b, l, r;
            cin >> a >> b >> l >> r;
            query cur;
            cur.l = l;
            cur.r = r;
            cur.idx = i;
            ask[a][b].push_back(cur);
        }
        bitset < smallsum > base;
        int bit = base._Find_first();
        bitset < smallsum > cur, zero_bit, st;
        for (int i = 1; i <= n; i ++)
        {
            ///cout << "reset" << endl;
            cur = zero_bit;
            for (int j = 0; j <= sum; j ++)
                block_sum[j] = pos_sum[j] = 0;
            cur[0] = 1;
            for (int j = i; j <= n; j ++)
            {

                                base = cur;
                cur = (cur | (cur << x[j]));
                st = (st | base);
                /** cout << "----------------" << endl;
                                 for (int j = 0; j < 20; j ++)
                     cout << cur[j] << " ";
                     cout << endl;
                 for (int j = 0; j < 20; j ++)
                     cout << base[j] << " ";
                     cout << endl;*/

                for (query cur_ask : ask[i][j])
                {
                    ///cout << "query " << cur_ask.l << " " << cur_ask.r << " " << cur_ask.idx << endl;
                    cur_ask.l = min(cur_ask.l, smallsum - 1);
                    cur_ask.r = min(cur_ask.r, smallsum - 2);


                }
            }

        }
        for (int i = 1; i <= q; i ++)
            cout << ans[i] << endl;
    }


}

int main()
{
    solve();
    return 0;
}
